
epsilon = 0.1; // utilisé pour éviter que les évidements se fassent mal
jeu = 1; // jeu à prévoir 

w = 3; 	    // width of the support, around the iphone+case, on the left and right side
e = 2;      // width of the front and rear planes
h = 150;    // height of the support

// chanfrain permettant à l'iphone de bien glisser
cfl = 1; // largeur
cfh = 3; // hauteur

module support(iphoneWidth, iphoneDepth, iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight) {
    supportPart1(iphoneWidth, iphoneDepth, iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight);
    supportPart2(iphoneWidth, iphoneDepth, iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight);
} 


module elements_a_ajouter() {
    elements_a_ajouter1();
    elements_a_ajouter2();
}

module elements_en_plus (){ // toujours présents
    elements_en_plus_1();
    elements_en_plus_2();
}

module supportPart1(iphoneWidth, iphoneDepth, iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight) {
    // iphoneWidth
    // iphoneDepth
    // iphoneHeight
    // Taille de l'iphone + case
    // iphoneBandeauHeight: hauteur (case compris) du bandeau du bas
    // iphoneBaseHeight: hauteur a rajouter au support pour couvrir le cable
    
    buttonWidth = 12; // largeur à prevoir autour du bouton de l'iPhone
                      // a verifier

    module bord_droit(){
        hull(){ // border right
            translate([0, e, 0]) 
                cube([w-cfl, iphoneDepth+e, iphoneBaseHeight+iphoneBandeauHeight]); 
            translate([w-cfl, e, 0]) 
                cube([cfl, iphoneDepth, iphoneBaseHeight+iphoneBandeauHeight-cfh]); 
        }
    }
    
    module bord_gauche(){
        hull(){ // border left
            translate([iphoneWidth+jeu+w+cfl, e, 0]) 
                cube([w-cfl, iphoneDepth+e, iphoneBaseHeight+iphoneBandeauHeight]); 
            translate([iphoneWidth+jeu+w, e, 0]) 
                cube([cfl, iphoneDepth, iphoneBaseHeight+iphoneBandeauHeight-cfh]); 
        }
    }
    
    module fond(){
        color("yellow") difference() {
            translate([w-cfl,e+iphoneDepth/2,0])
                cube([iphoneWidth+jeu+2*cfl,iphoneDepth/2+e, iphoneBaseHeight]);
            
            translate([0,0,-epsilon]) bord_droit();
            bord_droit();
            translate([0,0,-epsilon]) bord_gauche();
            bord_gauche();            
        }
    }

    module part1(iphoneWidth, iphoneDepth, iphoneHeight, 
        iphoneBandeauHeight, iphoneBaseHeight) {
        color("blue") 
            difference() {
                intersection() {
                    translate([w-cfl,e+iphoneDepth,0]) 
                        cube([iphoneWidth+jeu+2*cfl,e,iphoneBaseHeight+iphoneBandeauHeight]);
                    union () {
                        translate([0,e+iphoneDepth,iphoneBaseHeight]) {
                            hull() {
                                rotate([-90,0,0]) {
                                    translate([0,0,cfl])
                                        scale([(iphoneWidth+jeu)/2+w-buttonWidth/2,iphoneBandeauHeight,1])
                                            cylinder(e-cfl,r=1,$fn=100);
                                    translate([0,cfh,0])
                                        scale([(iphoneWidth+jeu)/2+w-buttonWidth/2,iphoneBandeauHeight,1])
                                            cylinder(cfl,r=1,$fn=100);
                                    }
                            } 
                        }
                        translate([iphoneWidth+jeu+2*w,e+iphoneDepth,iphoneBaseHeight]) {
                            hull() {
                                rotate([-90,0,0]) {
                                    translate([0,0,cfl])
                                        scale([(iphoneWidth+jeu)/2+w-buttonWidth/2,iphoneBandeauHeight,1])
                                            cylinder(e-cfl,r=1,$fn=100);
                                    translate([0,cfh,0])
                                        scale([(iphoneWidth+jeu)/2+w-buttonWidth/2,iphoneBandeauHeight,1])
                                            cylinder(cfl,r=1,$fn=100);
                                    }
                            } 
                        }
                    }
                }
                translate([0,0,-epsilon]) bord_droit();
                bord_droit();
                translate([0,0,-epsilon]) bord_gauche();
                bord_gauche();
                translate([0,epsilon,0]) fond();
                translate([0,0,-epsilon]) fond();
            }
        color("red")
            fond();
        color("yellow") {
            bord_droit();
            bord_gauche();
        }
    }
    difference() {
        union () {
            part1(iphoneWidth, iphoneDepth, iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight);
            elements_a_ajouter1();
        }
        elements_a_enlever();
    }
    elements_en_plus_1();
}


module supportPart2(iphoneWidth, iphoneDepth, iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight) {
    module part2(iphoneWidth, iphoneDepth, 
                iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight) {
            color("green") 
                cube([iphoneWidth + jeu + 2*w, e, h]); // plaque arrière
            color("red")
                translate([w + jeu/2,e,0])
                    cube([iphoneWidth,iphoneDepth/2,iphoneBaseHeight]); // fond
    }
    difference() {
        union () {
            part2(iphoneWidth, iphoneDepth, 
                iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight);
            elements_a_ajouter2();
        }
        elements_a_enlever();
    }
    elements_en_plus_2();
}


module passage_ecrou(ep /* ajustement de la position en Y */) {
    // ecrou
    ep = 0.4; //petit decalage d'ajustement de la position 
    translate([0,e+ep+iphoneDepth,0])
        rotate([90,90,0])
            cylinder(h_ecrou+jeu, d=(d_ecrou+jeu)/sqrt(3)*2, $fn=6);
    // passage
    translate([(d_ecrou+jeu)/2,e+ep+iphoneDepth-h_ecrou-jeu,0]) 
        rotate([0,180,0]) cube([d_ecrou+jeu,h_ecrou+jeu, d_ecrou+jeu+1000]);
    // trou pour la vis
    translate([0,e+ep+iphoneDepth-h_ecrou/2,0])
        rotate([90,0,0])
            cylinder(e+ep+iphoneDepth-h_ecrou/2, d=d_boulon+jeu, $fn=100);
    // chanfrein de la vis
    d_tete = 5.55; // diametre de la tete de vis 
    h_tete = 1.87; // epaisseur de la tete de vis 
    translate([0,h_tete+jeu-epsilon,0])
        rotate([90,0,0])
            cylinder(h_tete+jeu, d1=d_boulon+jeu, d2=d_tete+jeu, $fn=100);
}

module ecrous(
        dist /* distance du bord */, 
        hauteur_ecrous, 
        ep /* ajustement de la position en Y */) {
    for (i=[0,1]) {
        translate([i*(w*2+iphoneWidth+jeu-2*dist)+dist,0,hauteur_ecrous])
            passage_ecrou(ep);
    }
}

module ears(w_ears, h_ears, d_ears, a /* angle des ouies */) {
    H = iphoneBaseHeight; // assez grand pour aller jusqu'en bas 
    
    // ouies 
    for (z=[-1,1]) {
        translate([(iphoneWidth+jeu)/2+w-h_ears/2+z*(d_ears+h_ears/2),
                iphoneDepth/2+e-w_ears/2,
                iphoneBaseHeight+epsilon])
            rotate([a,0,0])
                translate([0,0,-H])
                    cube([h_ears,w_ears*cos(a),H]);
    }    
}

// not used
module ears_grid(w_ears, h_ears, d_ears) {
    //grilles des ouies
    for (z=[-1,1]) {
        s=0.5; // epaisseur de la grille
        for (i=[0:h_ears/s/2])
        {
            translate([(iphoneWidth+jeu)/2+w+z*(h_ears/2+d_ears/2)+z*i*2*s,
                    iphoneDepth+2*e-s,
                    0])
                cube([s,s,20]);
        }
    }
}

debug=1;
debug=0;

if (debug) {
    supportPart1(80, 10, 30, 15, 5);
    supportPart2(80, 10, 30, 15, 5);

    translate([-130,0,0]) {
        supportPart1(80, 10, 30, 15, 5);
        rotate([90,0,0])
            supportPart2(80, 10, 30, 15, 5);
    }
}