
include <Support.scad>


epsilon = 0.01; // utilisé pour éviter que les évidements se fassent mal
jeu = 1; // jeu à prévoir 

w = 3; 	    // width of the support, around the iphone+case, on the left and right side
e = 2;      // width of the front and rear planes
h = 100;    // height of the support (hauteur du vert)

// taille de l'iphone + case
// iphone 5S:
iphoneWidth=63;
iphoneDepth=11.9;
iphoneHeight=120;
iphoneBandeauHeight=21; // hauteur (case compris) du bandeau du bas
iphoneBaseHeight=22; // hauteur a rajouter au support pour couvrir le cable

d = 2.8; // diametre du cable

d_ecrou = 5.5; // taille de l'écrou 
h_ecrou = 2.35; // hauteur de l'écrou
d_boulon = 2.86; // a verifier: diametre du boulon

w_ears=3; // largeur des ouies 
h_ears=7; // longueur des ouies 
d_ears=14.5; // distance des ouies du centre de l'iphone 

/* la scene */
if (1) {
    supportPart1(iphoneWidth, iphoneDepth, 
        iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight);
}

if (1) {
    translate([80,0,0]) rotate([90,0,0]) {
        supportPart2(iphoneWidth, iphoneDepth, 
                iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight);
    }
}

if (1) {
    translate([-100,0,0]) {
        support(iphoneWidth, iphoneDepth, 
            iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight);
    }
}

/* les elements a rajouter ou enlever au support de base */
module elements_a_enlever() {
    passages_ecrous();
//    connector();
    translate([iphoneWidth+jeu+2*w,0,0]) mirror([1,0,0]) connector();
    ears(w_ears, h_ears, d_ears, 37);
}

module elements_en_plus_1 (){ // toujours présents
    //color("red") ears_grid();
}

module elements_en_plus_2 (){ // toujours présents
}

module elements_a_ajouter1() {
}

module elements_a_ajouter2() {
}

/* positionnement du passage des ecrous */
module passages_ecrous() {
    ep = 0.4; /* ajustement de la position en Y */
    ecrous(25,3.5, ep);
    ecrous(9,18.1, ep);
}




module connector() {
    gap=iphoneBaseHeight-14; 
    translate([(iphoneWidth+jeu)/2+w,e+iphoneDepth/2,0]) {
        
        w4=24.45+jeu;
        p4=5.65+jeu; 
        h4=6+epsilon; // mais on doit se retrouver à 1.2 du haut du bloc rouge
        H4=13.1; // du bas de la fiche;
        translate([0,0,H4+h4/2+gap-epsilon/2]) 
            cube([w4,p4,h4], center=true);

        w3=26.08+jeu;
        p3=7.6+jeu; 
        h3=H4;  
        H3=0; // du bas de la fiche
        translate([0,0,H3+h3/2+gap]) 
            cube([w3,p3,h3], center=true);

        // passe fil
        w2=31.05+jeu; 
        d2=5.6+jeu;
        H2=3.02; // du bas de la fiche 
        translate([-w3/2,-d2/2,H2+gap])
            translate([0,d2/2,d2/2]) rotate([0,90,0]) cylinder(w2,d=d2, $fn=100);
        
        // fil
        d1 = d+jeu;
        H1=H2+(d2-d1)/2; // du bas de la fiche 
        translate([0,0,H1+d1/2+gap])
            rotate([0,90,0])
                cylinder((iphoneWidth+jeu)/2,d=d1,$fn=100);

        // coude du fil
        r=5; //rayon de courbure du coude
        translate([(iphoneWidth+jeu)/2-(d+jeu)/2-r+r*sin(90/2),-r+r*sin(90/2),H1+d1/2+gap])
            rotate([90,0,45])
                cylinder(2*(r+d1/2)*tan(90/4),d=d1,$fn=100, center=true);
        translate([(iphoneWidth+jeu-d1)/2,0,H1+d1/2+gap])
            rotate([90,0,0])
                cylinder(iphoneDepth/2+e+epsilon,d=d1,$fn=100);
        
        // allongement de trou pour passer le fil dans la plaque verte
        translate([(iphoneWidth+jeu)/2-d1/2,-e-iphoneDepth/2-epsilon/2,H1+gap])
            cube([w+(d+jeu)/2+epsilon,e+epsilon,d+jeu]);
   }
}
