
// selection du cable:
// 1: cable normal lightspeed
CABLE_LIGHTSPEED=1;
// 2: cable coudé lightspeed
CABLE_COUDE_LIGHTSPEED=2;

cable=CABLE_COUDE_LIGHTSPEED; 
//cable=CABLE_LIGHTSPEED; 

include <Support.scad>


epsilon = 0.01; // utilisé pour éviter que les évidements se fassent mal
jeu = 1; // jeu à prévoir 

w = 3; 	    // width of the support, around the iphone+case, on the left and right side
e = 2;      // width of the front and rear planes
h = 100;    // height of the support (hauteur du vert)

// taille de l'iphone + case
// iphone 5S:
iphoneWidth=62;
iphoneDepth=10.2;
iphoneHeight=127;
iphoneBandeauHeight=20; // hauteur (case compris) du bandeau du bas
iphoneBaseHeight=22; // hauteur a rajouter au support pour couvrir le cable

d = 2.8; // diametre du cable

d_ecrou = 5.5; // taille de l'écrou 
h_ecrou = 2.35; // hauteur de l'écrou
d_boulon = 2.86; // a verifier: diametre du boulon

w_ears=5.4; // largeur des ouies 
h_ears=13.7; // longueur des ouies 
d_ears=6.9; // distance des ouies du centre de l'iphone 

/* la scene */
supportPart1(iphoneWidth, iphoneDepth, 
    iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight);

if (1) {
    translate([80,0,0]) rotate([90,0,0]) {
        supportPart2(iphoneWidth, iphoneDepth, 
                iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight);
    }
}

if (1) {
    translate([-100,0,0]) {
        support(iphoneWidth, iphoneDepth, 
            iphoneHeight, iphoneBandeauHeight, iphoneBaseHeight);
    }
}

/* les elements a rajouter ou enlever au support de base */
module elements_a_enlever() {
    passages_ecrous();
    connector();
    translate([iphoneWidth+jeu+2*w,0,0]) mirror([1,0,0]) connector();
    ears(w_ears, h_ears, d_ears, 30);
}

module elements_en_plus_1 (){ // toujours présents
    //color("red") ears_grid();
}

module elements_en_plus_2 (){ // toujours présents
}

module elements_a_ajouter1() {
}

module elements_a_ajouter2() {
}

/* positionnement du passage des ecrous */
module passages_ecrous() {
    ep = 0.4; /* ajustement de la position en Y */
    ecrous(21,3.5, ep);
    ecrous(9,16.5, ep);
}




module connector() {
    if (cable==CABLE_LIGHTSPEED) 
        lightning_connector();
    if (cable==CABLE_COUDE_LIGHTSPEED) 
        lightning_connector_coude();
}

// lightning connector
module lightning_connector() {
	union () {
		scale([1,4.6/7.6,1]) translate([0,0,15]) cylinder(12+epsilon, r=7.6, $fn=100);
		translate([0,0,5]) cylinder(10+epsilon, r=3.4, $fn=100);
		translate([0,0,-epsilon]) cylinder(5+2*epsilon, r=d/2, $fn=100);

        // passefil vertical
        translate([-d/2,-iphoneDepth/2-epsilon,-epsilon])
            cube([d,iphoneDepth/2+epsilon,baseHeight+2*epsilon]);
	}
}

module lightning_connector_coude() {
    gap=iphoneBaseHeight-17; 
    translate([(iphoneWidth+jeu)/2+w,e+iphoneDepth/2,0]) {
        translate([0,0,17/2+gap+epsilon/2]) 
            cube([9+jeu,6+jeu,17+epsilon], center=true);
        translate([-(9+jeu)/2,-(6+jeu)/2,gap])
            cube([14+jeu,6+jeu,6]);
        translate([0,0,6/2+gap])
            rotate([0,90,0])
                cylinder((iphoneWidth+jeu)/2,d=d+jeu,$fn=100);

        // coude du fil
        r=5; //rayon de courbure du coude
        translate([(iphoneWidth+jeu)/2-(d+jeu)/2-r+r*sin(90/2),-r+r*sin(90/2),(5+jeu)/2+gap])
            rotate([90,0,45])
                cylinder(2*(r+(d+jeu)/2)*tan(90/4),d=d+jeu,$fn=100, center=true);
        translate([(iphoneWidth-d)/2,0,(5+jeu)/2+gap])
            rotate([90,0,0])
                cylinder(iphoneDepth/2+e+epsilon,d=d+jeu,$fn=100);
        
    }
    // allongement de trou pour passer le fil dans la plaque verte
    translate([w+iphoneWidth+jeu-(d+jeu)/2,-epsilon/2,6/2+gap-(d+jeu)/2])
         cube([w+(d+jeu)/2+epsilon,e+epsilon,d+jeu]);
}
